//+------------------------------------------------------------------+
//|                                                     TmaSlope.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, zznbrm"

//Edited by shahrooz "sh.sadeghi.me@gmail.com"  
//Modified by Jack1  "https://twitter.com/Jack1Fx"                        
//---- indicator settings
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Green          //Up1   up trend 
#property indicator_color2 Lime           //Up2   up trend strong
#property indicator_color3 FireBrick      //Dn1   Dn trend
#property indicator_color4 Red            //Dn2   Dn trend strong
#property indicator_color5 DarkGray       //Mid1  range
#property indicator_color6 LightSlateGray //Mid2  range strong
#property indicator_color7 EMPTY

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2  
#property indicator_width6 2   
#property indicator_width7 0   

//---- input parameters
extern bool show_1st_MTF   =true;
extern string TimeFrame_1st = "Select below 0=current tf,1,5,15,30,60,240,1440,10080,43200";
extern int select_1st_tf_to_show=60; //M60
extern int H_Pos_MTF       =1;
extern int V_Pos_MTF       =30;
extern int Font_Size_MTF   =10;
extern int Corner_MTF      =3;   //corner 3
color      Font_Color_MTF;

//---- input parameters
extern bool show_2nd_MTF   =true;
extern string OtherTimeFrame_2nd = "Select below 0=current tf,1,5,15,30,60,240,1440,10080,43200";
extern int select_2nd_tf_to_show=240;
extern int H_Pos_MTF_2nd      =1;
extern int V_Pos_MTF_2nd      =45;
extern int Font_Size_MTF_2nd  =10;
extern int Corner_MTF_2nd     =3;
color      Font_Color_MTF_2nd;

extern bool show_3rd_MTF   =true;
extern string OtherTimeFrame_3rd = "Select below 0=current tf,1,5,15,30,60,240,1440,10080,43200";
extern int select_3rd_tf_to_show=1440;
extern int H_Pos_MTF_3rd      =1;
extern int V_Pos_MTF_3rd      =60;
extern int Font_Size_MTF_3rd  =10;
extern int Corner_MTF_3rd     =3;
color      Font_Color_MTF_3rd;
 
extern int eintPeriod = 21;//56;
extern int atrPeriod  = 100;
extern double eHigh1 =  0.5;  //strong up trend, only buy
extern double eLow1  = -0.5;  //strong dn trend, only sell

extern color Font_Color          = White;
extern int   H_Pos               = 1;
extern int   V_Pos               = 15;
extern int   Corner              = 3;
extern int   Font_Size           = 10;

extern int   H_Pos_text          = 1;
extern int   V_Pos_text          = 1;
extern int   Corner_Text         = 3;
extern int   Font_Size_text      = 10;

//---- indicator buffers
double Up1[];
double Up2[];

double Dn1[];
double Dn2[];

double Mid1[];
double Mid2[];

double Slope[]; 
color  Font_Color_M15;

double TICK;
bool AdditionalDigit;

int    OldBars=0;
string TimeFrameStr,TimeFrameStr2,TimeFrameStr3;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{              
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,eHigh1);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,eLow1 );
 
   IndicatorBuffers( 7 );
   IndicatorDigits( 5 );
   IndicatorShortName( "TmaSlope_jack1" );
      
   SetIndexBuffer( 0, Up1  );    SetIndexLabel( 0, NULL );       SetIndexStyle( 0, DRAW_HISTOGRAM );
   SetIndexBuffer( 1, Up2  );    SetIndexLabel( 1, NULL );       SetIndexStyle( 1, DRAW_HISTOGRAM );
   SetIndexBuffer( 2, Dn1  );    SetIndexLabel( 2, NULL );       SetIndexStyle( 2, DRAW_HISTOGRAM );
   SetIndexBuffer( 3, Dn2  );    SetIndexLabel( 3, NULL );       SetIndexStyle( 3, DRAW_HISTOGRAM );
   SetIndexBuffer( 4, Mid1 );    SetIndexLabel( 4, NULL );       SetIndexStyle( 4, DRAW_HISTOGRAM );
   SetIndexBuffer( 5, Mid2 );    SetIndexLabel( 5, NULL );       SetIndexStyle( 5, DRAW_HISTOGRAM );

   SetIndexBuffer( 6, Slope );   SetIndexLabel( 6, "TMA Slope" );    SetIndexStyle( 6, DRAW_NONE );
      
   SetIndexEmptyValue( 0, 0.0 );
   SetIndexEmptyValue( 1, 0.0 );
   SetIndexEmptyValue( 2, 0.0 );
   SetIndexEmptyValue( 3, 0.0 );
   SetIndexEmptyValue( 4, 0.0 );
   SetIndexEmptyValue( 5, 0.0 );
   
   switch(select_1st_tf_to_show)
      {
      case 1 : TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current";
      } 
   
   switch(select_2nd_tf_to_show)
      {
      case 1 : TimeFrameStr2="M1"; break;
      case 5 : TimeFrameStr2="M5"; break;
      case 15 : TimeFrameStr2="M15"; break;
      case 30 : TimeFrameStr2="M30"; break;
      case 60 : TimeFrameStr2="H1"; break;
      case 240 : TimeFrameStr2="H4"; break;
      case 1440 : TimeFrameStr2="D1"; break;
      case 10080 : TimeFrameStr2="W1"; break;
      case 43200 : TimeFrameStr2="MN1"; break;
      default : TimeFrameStr2="Current";
      }
   
   switch(select_3rd_tf_to_show)
      {
      case 1 : TimeFrameStr3="M1"; break;
      case 5 : TimeFrameStr3="M5"; break;
      case 15 : TimeFrameStr3="M15"; break;
      case 30 : TimeFrameStr3="M30"; break;
      case 60 : TimeFrameStr3="H1"; break;
      case 240 : TimeFrameStr3="H4"; break;
      case 1440 : TimeFrameStr3="D1"; break;
      case 10080 : TimeFrameStr3="W1"; break;
      case 43200 : TimeFrameStr3="MN1"; break;
      default : TimeFrameStr3="Current";
      }
      
   OldBars=Bars-2;
   
   return( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
{ 
   RemoveObjects("TmaSlope_");
   return(0);
}
//-------------------------------------------------------------------+
void RemoveObjects(string prefix)
//-------------------------------------------------------------------+
{   
   int i;
   string objname;

   for (i = ObjectsTotal(); i >= 0; i--) 
   {
      objname = ObjectName(i);
      if (StringFind(objname, prefix, 0) > -1) ObjectDelete(objname);
   }
} 

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   //check if a new bar, then, do a run
   if(OldBars==Bars) return(0);
   OldBars=Bars;//a new bar, run further down, reset this flag
   
   int counted_bars = IndicatorCounted();
   if ( counted_bars < 0 ) return(-1);
   if ( counted_bars > 0 ) counted_bars--;
               
   int intLimit = MathMin( Bars - 1, Bars - counted_bars + eintPeriod );
   
   double Tma,     Prev;
   double TmaMTF,  PrevMTF;
   double TmaMTF2, PrevMTF2;
   double TmaMTF3, PrevMTF3;
   
   double atr ; 
   double atrMTF;
   double atrMTF2;
   double atrMTF3;
   
   //-- main loop
   for( int inx = intLimit; inx >= 0; inx-- )
   {  //calculate ATR     
      atr    = iATR(NULL,0, atrPeriod,inx+10)*0.1;
            
      if (atr == 0) continue;   //return for next loop
      
      //calculate tma for current chart
      Tma  = calcTma( inx   );
      Prev = calcTma( inx+1 );
      Slope[inx] = ( Tma - Prev ) / atr;
      
      Up1[inx] = 0.0;   
      Dn1[inx] = 0.0;     
      Mid1[inx]= 0.0;   
      Up2[inx] = 0.0;   
      Dn2[inx] = 0.0;     
      Mid2[inx]= 0.0;   
   
      if ( Slope[inx] > eHigh1 )
      {
         if(Slope[inx] < Slope[inx+1]) 
            Up1[inx] = Slope[inx];
         else 
            Up2[inx] = Slope[inx];//strong up trend
      }
      else 
      if ( Slope[inx] < eLow1 )
      {
         if(Slope[inx] < Slope[inx+1]) 
            Dn2[inx] = Slope[inx];//strong dn trend
         else 
            Dn1[inx] = Slope[inx];
      }
      else  
      {
         if(Slope[inx] < Slope[inx+1]) 
            Mid2[inx] = Slope[inx];//strong range
         else 
            Mid1[inx] = Slope[inx];
      } 
   
      //show slop[0]
      if(inx==0)
      {
         string tt=DoubleToStr(Slope[inx], 2);//slop value

         ObjectCreate ("TmaSlope_label",OBJ_LABEL,WindowFind("TmaSlope_jack1"),0,0);
         ObjectSet    ("TmaSlope_label",OBJPROP_XDISTANCE,H_Pos);
         ObjectSet    ("TmaSlope_label",OBJPROP_YDISTANCE,V_Pos);
         ObjectSet    ("TmaSlope_label",OBJPROP_CORNER,  Corner);
         ObjectSetText("TmaSlope_label",tt+"       ",Font_Size,"Arial",Font_Color);
   
         string sObjName1="TmaSlope_InfoBar1";
         ObjectCreate (sObjName1, OBJ_LABEL,WindowFind("TmaSlope_jack1"), 0, 0);
         ObjectSet    (sObjName1, OBJPROP_CORNER,    Corner_Text);
         ObjectSet    (sObjName1, OBJPROP_XDISTANCE, H_Pos_text);//left to right
         ObjectSet    (sObjName1, OBJPROP_YDISTANCE, V_Pos_text);//top to bottom

         if (Slope[inx] >= eHigh1)
            ObjectSetText(sObjName1, "Buy Only ", Font_Size_text, "Verdana", YellowGreen);
         else 
         if (Slope[inx] <= eLow1)
            ObjectSetText(sObjName1, "Sell Only ", Font_Size_text, "Verdana", Red);
         else 
            ObjectSetText(sObjName1, "Ranging ", Font_Size_text, "Verdana", DarkGray);
      }//end if 
   }//end for
   
      //------------------
      //other 3 time frame
      //------------------
      inx =1;
      atrMTF = iATR(NULL,select_1st_tf_to_show,  atrPeriod,inx+10)*0.1;
      atrMTF2= iATR(NULL,select_2nd_tf_to_show,  atrPeriod,inx+10)*0.1;
      atrMTF3= iATR(NULL,select_3rd_tf_to_show,  atrPeriod,inx+10)*0.1;
      
      //calculate tma in 3 other MTF
      if(show_1st_MTF && atrMTF !=0)// && Period()<= select_1st_tf_to_show)
      {
         TmaMTF  = calcTmaMTF( 0 , select_1st_tf_to_show );
         PrevMTF = calcTmaMTF( 1 , select_1st_tf_to_show );
         double hh  = ( TmaMTF - PrevMTF ) / atrMTF;
         if (hh>= eHigh1) Font_Color_MTF=Lime;
         else 
         if (hh<= eLow1)  Font_Color_MTF=Red;
         else             Font_Color_MTF=DarkGray;
         string jj=DoubleToStr(hh,2);
      
         ObjectCreate ("TmaSlope_label MTF",OBJ_LABEL,WindowFind("TmaSlope_jack1"),0,0);
         ObjectSet    ("TmaSlope_label MTF",OBJPROP_XDISTANCE,H_Pos_MTF);
         ObjectSet    ("TmaSlope_label MTF",OBJPROP_YDISTANCE,V_Pos_MTF);
         ObjectSet    ("TmaSlope_label MTF",OBJPROP_CORNER,   Corner_MTF);
         ObjectSetText("TmaSlope_label MTF",jj+"  "+TimeFrameStr+" ",Font_Size_MTF,"Arial",Font_Color_MTF);
      }
      else ObjectDelete("TmaSlope_label MTF");
   
      if(show_2nd_MTF && atrMTF2 !=0)// && Period()<= select_2nd_tf_to_show)
      {
         TmaMTF2  = calcTmaMTF( 0 , select_2nd_tf_to_show );
         PrevMTF2 = calcTmaMTF( 1 , select_2nd_tf_to_show );
         hh = ( TmaMTF2 - PrevMTF2 ) / atrMTF2;
         if(hh>=eHigh1) Font_Color_MTF_2nd=Lime;
         else 
         if(hh<=eLow1)  Font_Color_MTF_2nd=Red;
         else           Font_Color_MTF_2nd=DarkGray;
         jj=DoubleToStr(hh,2);
         ObjectCreate("TmaSlope_label MTF_2nd",OBJ_LABEL,WindowFind("TmaSlope_jack1"),0,0);
         ObjectSet("TmaSlope_label MTF_2nd",OBJPROP_XDISTANCE,H_Pos_MTF_2nd);
         ObjectSet("TmaSlope_label MTF_2nd",OBJPROP_YDISTANCE,V_Pos_MTF_2nd);
         ObjectSet("TmaSlope_label MTF_2nd",OBJPROP_CORNER,Corner_MTF_2nd);
         ObjectSetText("TmaSlope_label MTF_2nd",jj+"  "+TimeFrameStr2+" ",Font_Size_MTF_2nd,"Arial",Font_Color_MTF_2nd);
      }
      else ObjectDelete("TmaSlope_label MTF_2nd");
   
      if(show_3rd_MTF && atrMTF3 !=0)// && Period()<= select_3rd_tf_to_show)
      {
         TmaMTF3  = calcTmaMTF( 0 , select_3rd_tf_to_show );
         PrevMTF3 = calcTmaMTF( 1 , select_3rd_tf_to_show );
         hh = ( TmaMTF3 - PrevMTF3 ) / atrMTF3;
         if(hh>=eHigh1)   Font_Color_MTF_3rd=YellowGreen;
         else 
         if(hh<=eLow1) Font_Color_MTF_3rd=Red;
         else          Font_Color_MTF_3rd=DarkGray;
         jj=DoubleToStr(hh,2);
         ObjectCreate("TmaSlope_label MTF_3rd",OBJ_LABEL,WindowFind("TmaSlope_jack1"),0,0);
         ObjectSet("TmaSlope_label MTF_3rd",OBJPROP_XDISTANCE,H_Pos_MTF_3rd);
         ObjectSet("TmaSlope_label MTF_3rd",OBJPROP_YDISTANCE,V_Pos_MTF_3rd);
         ObjectSet("TmaSlope_label MTF_3rd",OBJPROP_CORNER,Corner_MTF_3rd);
         ObjectSetText("TmaSlope_label MTF_3rd",jj+"  "+TimeFrameStr3+" ",Font_Size_MTF_3rd,"Arial",Font_Color_MTF_3rd);
      }
      else ObjectDelete("TmaSlope_label MTF_3rd");
   
   //done
   return( 0 );
}

//+------------------------------------------------------------------+
//| getTick()                                                        |
//+------------------------------------------------------------------+
double getTick() {
    double tick = MarketInfo(Symbol(), MODE_TICKSIZE);
    if (AdditionalDigit) {
        tick *= 10;
    }    
    return (tick);
}

//+------------------------------------------------------------------+
//| calcTma()                                                        |
//+------------------------------------------------------------------+
double calcTma( int inx )
{
   double Sum  = (eintPeriod+1)*Close[inx];
   double Sumw = (eintPeriod+1);
   int jnx, knx;
         
   for ( jnx = 1, knx = eintPeriod; jnx <= eintPeriod; jnx++, knx-- )
   {
      Sum  += ( knx * Close[inx+jnx] );
      Sumw += knx;

      if ( jnx <= inx )
      {
         Sum  += ( knx * Close[inx-jnx] );
         Sumw += knx;
      }
   }
   return( Sum / Sumw );
}
 
 
double calcTmaMTF( int inx , int tf)
{
   double Sum  = (eintPeriod+1)*iClose(Symbol(),tf,inx);
   double Sumw = (eintPeriod+1);
   int jnx, knx;
         
   for ( jnx = 1, knx = eintPeriod; jnx <= eintPeriod; jnx++, knx-- )
   {
      Sum  += ( knx * iClose(Symbol(),tf,inx+jnx) );
      Sumw += knx;

      if ( jnx <= inx )
      {
         Sum  += ( knx * iClose(Symbol(),tf,inx-jnx) );
         Sumw += knx;
      }
   }
   return( Sum / Sumw );
}
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 



   


